/* カード */
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.BevelBorder;


public class Card extends JButton implements ActionListener {
	public int order1, order2, attrib;
	public Page page;
	public Expansion expansion;
	public String name;
	protected Color color1, color2;
	private BufferedImage imgC, imgG;
	private BevelBorder raised = new BevelBorder(BevelBorder.RAISED), lowered = new BevelBorder(BevelBorder.LOWERED);
	public boolean selected = false, disabled;
	public CardImage cardImg;

	public void paintComponent(Graphics g){
		super.paintComponent(g);
		if (imgC != null && imgG != null) g.drawImage(selected && expansion.isSelected() ? imgC : imgG, 10, 10, null);
	}

	public void setSelected(boolean value){
		if (value){
			selected = true;
			setBorder(lowered);
			setBackground(expansion.isSelected() ? color2 : Color.LIGHT_GRAY);
		} else {
			selected = false;
			setBorder(raised);
			setBackground(Color.LIGHT_GRAY);
		}
	}

	public void checkChanged(){
		setSelected(selected);
		repaint();
	}

	public boolean isAvailable(){
		return selected && !disabled && (expansion.maxVal > 0);
	}

	public Card(int order1, int order2, Page page, Expansion expansion, int attrib, String name, String imgName){
		this.order1 = order1;
		this.order2 = order2;
		this.page = page;
		this.expansion = expansion;
		this.attrib = attrib;
		this.name = name;
		this.color1 = page.color1;
		this.color2 = page.color2;

		try {
			if ((imgC = javax.imageio.ImageIO.read(new java.io.File(DominionSupply.appPath, "Image/" + imgName + ".png"))) == null) throw new Exception();
		} catch (Exception ex){
			JOptionPane.showMessageDialog(null, "ファイル " + imgName + ".png が見つかりません", "エラー", JOptionPane.ERROR_MESSAGE);
			System.exit(0);
		}
		imgG = new BufferedImage(imgC.getWidth(), imgC.getHeight(), BufferedImage.TYPE_BYTE_GRAY);
		imgG.createGraphics().drawImage(imgC, 0, 0, null);
		cardImg = new CardImage(imgC, color2);
		setSelected(true);
		setOpaque(true);

		((CardPage)page).add(this);
		expansion.add(this);

		setPreferredSize(new Dimension(20 + imgC.getWidth(), 20 + imgC.getHeight()));
		addActionListener(this);
	}

	public void actionPerformed(ActionEvent e){
		setSelected(!selected);
	}
}

