/* カード選択ページ */
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class CardPage extends Page implements ActionListener {
	private JButton allTrue = new JButton("全選択"), allFalse = new JButton("全解除");
	protected JPanel north = new JPanel(), south = new JPanel();
	public JCheckBox alchemy;

	/* 画面左側に表示するタブ */
	class CardPageTab extends JButton implements ActionListener, ChangeListener {
		private JLabel label;
		public JCheckBox checkbox = new JCheckBox();
		
		public CardPageTab(String text){
			setBackground(color1);
			setFocusPainted(false);
			setBorderPainted(false);
			setContentAreaFilled(false);
			setPreferredSize(new Dimension(200, 30));
			setMargin(new Insets(2, 15, 2, 15));
			setLayout(new BorderLayout());

			label = new JLabel(text);
			label.setForeground(color1);
			label.setFont(font16);
			add(label, BorderLayout.CENTER);
			addActionListener(this);

			add(checkbox, BorderLayout.WEST);
			checkbox.setFont(font16);
			checkbox.setContentAreaFilled(false);
			checkbox.addChangeListener(this);
		}

		public void setTabColor(boolean value){
			label.setForeground(value ? Color.WHITE : color1);
			setContentAreaFilled(value);
		}
		
		public void actionPerformed(ActionEvent e){
			MainFrame.instance.switchPage(page_no);
		}

		public void stateChanged(ChangeEvent e){
			checkChanged(checkbox.isSelected());
		}
	}

	/* コンストラクタ */
	public CardPage(int page_no, String title, Color color1, Color color2, int numberOfCards){
		super(page_no, title, color1, color2);
		tab = new CardPageTab(title);
		cards = new ArrayList<Card>(numberOfCards);
		allTrue.addActionListener(this);
		allFalse.addActionListener(this);

		JPanel north1 = new JPanel();
		add(contentPane, BorderLayout.CENTER);
		contentPane.setOpaque(false);
		contentPane.setBorder(BorderFactory.createEmptyBorder(10, 20, 10, 20));
		contentPane.setLayout(new BorderLayout());
		contentPane.add(north, BorderLayout.NORTH); north.setOpaque(false); north.setLayout(new MyFlowLayout(FlowLayout.LEFT, 0, 5));
			north.add(north1); north1.setOpaque(false); north1.setLayout(new BoxLayout(north1, BoxLayout.X_AXIS));
			north1.add(allTrue); allTrue.setFont(font16); allTrue.setMargin(new Insets(0, 15, 0, 15));
			north1.add(Box.createHorizontalStrut(10));
			north1.add(allFalse); allFalse.setFont(font16); allFalse.setMargin(new Insets(0, 15, 0, 15));
			north1.add(Box.createHorizontalStrut(20));
		contentPane.add(south, BorderLayout.CENTER); south.setOpaque(false); south.setLayout(new MyFlowLayout(FlowLayout.LEFT, 5, 5));
			south.setBorder(BorderFactory.createEmptyBorder(5, 0, 0, 0));

		repaint();
	}

	public void add(Card card){
		cards.add(card);
		south.add(card);
	}

	public void setTabColor(boolean value){
		((CardPageTab)tab).setTabColor(value);
	}

	public void checkChanged(boolean value){
		setBackground(value ? Color.WHITE : Color.LIGHT_GRAY);
		for (Card card : cards) card.checkChanged();
		repaint();
	}

	public boolean isSelected(){
		return ((CardPageTab)tab).checkbox.isSelected();
	}

	public void setSelected(boolean value){
		((CardPageTab)tab).checkbox.setSelected(value);
		checkChanged(value);
	}

	public void actionPerformed(ActionEvent e){
		if (e.getSource() == allTrue){
			for (Card card : cards) card.setSelected(true);
		} else if (e.getSource() == allFalse){
			for (Card card : cards) card.setSelected(false);
		}
	}
}

