/* 起動クラス・プログラム全体で共有する定数等 */
import java.util.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import javax.swing.*;


public class DominionSupply {
	private static final int NORMAL = 0, TRASH = 1, ACTION = 2, BUY = 4, BANE = 8;
	public static String appPath = "";
	public static BufferedImage imgBack = null;
	public static MainFrame frame;
	public static boolean isMac = false;

	public static void main(String[] args){
		/* Mac OS X 用の設定 */
		String osName = System.getProperty("os.name").toLowerCase();
		if (isMac = (osName.indexOf("os x") >= 0)){
			System.setProperty("apple.laf.useScreenMenuBar", "true");
			System.setProperty("com.apple.mrj.application.apple.menu.about.name", "Dominion サプライ選択装置");
		}

		new DominionSupply();
	}

	public DominionSupply(){
		/* デフォルトの sans-serif フォントを使用 */
		Font font = new Font(Font.SANS_SERIF, Font.PLAIN, 14);
		Enumeration<Object> keys = UIManager.getDefaults().keys();
		while (keys.hasMoreElements()){
			Object key = keys.nextElement();
			if (UIManager.get(key) instanceof Font) UIManager.put(key.toString(), font);
		}

		/* パスの取得 */
		String tmp = this.getClass().getProtectionDomain().getCodeSource().getLocation().getPath().replaceAll(" ", "%20").replaceAll("\\+", "%2b");
		try {
			appPath = java.net.URLDecoder.decode(tmp, "UTF-8");
		} catch (Exception ex){
			appPath = tmp;
		}
		if (appPath.toLowerCase().endsWith(".jar")) appPath = new java.io.File(appPath).getParent();

		/* 画像ファイルの取得 */
		try {
			if ((imgBack = javax.imageio.ImageIO.read(new java.io.File(appPath, "Image/Back.png"))) == null) throw new Exception();
		} catch (Exception ex){
			JOptionPane.showMessageDialog(null, "ファイル Back.png が見つかりません", "エラー", JOptionPane.ERROR_MESSAGE);
			System.exit(0);
		}

		/* 拡張とカードのデータの初期化・取得 */
		CardData.init();

		/* フレームの表示 */
		frame = new MainFrame(CardData.pages);
		frame.setVisible(true);
	}
}

