/* BorderLayout の中でも使えるようにした FlowLayout */
import java.awt.*;


public class MyFlowLayout extends FlowLayout {
	public Dimension preferredLayoutSize(Container target){
		synchronized (target.getTreeLock()){
			Insets insets = target.getInsets();
				if (insets == null) insets = new Insets(0, 0, 0, 0);
				int hgap = getHgap(), vgap = getVgap(), width = target.getWidth() - (insets.left + insets.right + 2 * hgap);
				int left = 0, top = insets.top + insets.bottom + vgap, tmp = 0;

				int n = target.getComponentCount();
				for (int i = 0; i < n; i++) {
					Component c = target.getComponent(i);
					if (!c.isVisible()) continue;

					Dimension d = c.getPreferredSize();
					if (left == 0){
						left = d.width;
						tmp = d.height;
					} else if ((left += hgap + d.width) > width){
						left = d.width;
						top += vgap + tmp;
						tmp = d.height;
					} else {
						if (d.height <= tmp) continue;
						tmp = d.height;
					}
				}
			return new Dimension(target.getWidth(), top + tmp);
		}
	}

	public MyFlowLayout(int align, int hgap, int vgap){
		super(align, hgap, vgap);
	}
}

