/* 表示する各ページの抽象クラス */
import java.util.*;
import java.awt.*;
import javax.swing.*;


abstract public class Page extends JPanel {
	protected static final Font font16 = new Font("SansSerif", 0, 16);
	protected JLabel titleLabel = new JLabel(){
		public void paintComponent(Graphics g){
			super.paintComponent(g);
			g.setColor(Color.GRAY);
			((Graphics2D)g).setStroke(new BasicStroke(3.0f));
			g.drawLine(20, getHeight() - 7, getWidth() - 30, getHeight() - 7);
		}
	};
	protected JPanel contentPane = new JPanel();
	protected Color color1 = Color.RED, color2 = Color.WHITE;
	public int page_no;
	public String title;
	public JButton tab;
	public java.util.List<Card> cards = null;

	/* コンストラクタ */
	public Page(int page_no, String title, Color color1, Color color2){
		this.page_no = page_no;
		this.title = title;
		this.color1 = color1;
		this.color2 = color2;
		setLayout(new BorderLayout());
		setBackground(Color.WHITE);

		add(titleLabel, BorderLayout.NORTH);
		titleLabel.setText(title);
		titleLabel.setFont(new Font("SansSerif", 0, 32));
		titleLabel.setBorder(BorderFactory.createEmptyBorder(15, 20, 10, 10));
		titleLabel.setForeground(color1);

		add(contentPane, BorderLayout.CENTER);
		contentPane.setOpaque(false);

		repaint();
	}

	public void setTabColor(boolean value){}
	public void checkChanged(boolean value){}
	public boolean isSelected(){ return true; }
	public void setSelected(boolean value){}

	/* ゲッタ・セッタ */
	public int getMin(){ return 0; }
	public void setMin(int value){}
	public int getMax(){ return 10; }
	public void setMax(int value){}
}

