/* 「全体の設定」ページ */
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class SettingPage extends Page implements ActionListener {
	private JSpinner
		needNumberSpinner = new JSpinner(new SpinnerNumberModel(10, 1, 10, 1));
	private JCheckBox
		checkUncheck = new JCheckBox("抽出されたカードの選択を自動的に解除する"),
		checkTrash = new JCheckBox("他のカードを廃棄できるカードを1枚以上含める"),
		checkAction = new JCheckBox("追加のアクション権を得るカードを1枚以上含める"),
		checkBuy = new JCheckBox("追加の購入権を得るカードを1枚以上含める");
	private JRadioButton
		radioSort1 = new JRadioButton("拡張セット別コスト順"),
		radioSort2 = new JRadioButton("コスト順"),
		radioBMarket1 = new JRadioButton("選択されたカードのみ（通常の抽出範囲と同じ）"),
		radioBMarket2 = new JRadioButton("チェックの付いた拡張セット全体");
	private JButton
		showBMarket = new JButton("闇市場デッキ生成器を起動");

	/* 画面左側に表示するタブ */
	class SettingPageTab extends JButton implements ActionListener {
		private JLabel label;
		
		public SettingPageTab(String text){
			setBackground(color1);
			setFocusPainted(false);
			setBorderPainted(false);
			setContentAreaFilled(false);
			setPreferredSize(new Dimension(200, 30));
			setMargin(new Insets(2, 15, 2, 15));
			setLayout(new BorderLayout());

			label = new JLabel(text);
			label.setForeground(color1);
			label.setFont(font16);
			add(label, BorderLayout.CENTER);
			addActionListener(this);
		}
		
		public void setTabColor(boolean value){
			label.setForeground(value ? Color.WHITE : color1);
			setContentAreaFilled(value);
		}
		
		public void actionPerformed(ActionEvent e){
			MainFrame.instance.switchPage(page_no);
		}
	}

	/* コンストラクタ */
	public SettingPage(int page_no){
		super(page_no, "全体の設定", new Color(64, 64, 64), Color.LIGHT_GRAY);
		tab = new SettingPageTab("全体の設定");

		JPanel settings = new JPanel(), tmp, tmp2;
		contentPane.setBorder(BorderFactory.createEmptyBorder(20, 50, 10, 10));
		contentPane.setLayout(new BorderLayout());
		contentPane.add(settings, BorderLayout.NORTH);
		settings.setLayout(new BoxLayout(settings, BoxLayout.Y_AXIS));
		settings.setOpaque(false);
		settings.add(tmp = new JPanel());
			tmp.setAlignmentX(JComponent.LEFT_ALIGNMENT);
			tmp.setLayout(new BorderLayout());
			tmp.setOpaque(false);
			tmp.add(tmp2 = new JPanel(), BorderLayout.WEST);
			tmp2.setLayout(new BorderLayout());
			tmp2.setOpaque(false);
			tmp2.add(new JLabel("1回のシャッフルで抽出する枚数: "), BorderLayout.WEST);
			tmp2.add(needNumberSpinner, BorderLayout.CENTER); needNumberSpinner.setPreferredSize(new Dimension(50, 24));
			tmp2.add(new JLabel(" 枚"), BorderLayout.EAST);
		settings.add(Box.createVerticalStrut(20));
		settings.add(checkUncheck);	checkUncheck.setAlignmentX(JComponent.LEFT_ALIGNMENT);	checkUncheck.setOpaque(false);
		settings.add(Box.createVerticalStrut(20));
		settings.add(checkTrash);	checkTrash.setAlignmentX(JComponent.LEFT_ALIGNMENT);	checkTrash.setOpaque(false);
		settings.add(checkAction);	checkAction.setAlignmentX(JComponent.LEFT_ALIGNMENT);	checkAction.setOpaque(false);
		settings.add(checkBuy);	checkBuy.setAlignmentX(JComponent.LEFT_ALIGNMENT);	checkBuy.setOpaque(false);
		settings.add(Box.createVerticalStrut(20));
		settings.add(new JLabel("抽出されたカードの並び順:"));
		ButtonGroup radioSort = new ButtonGroup();
			settings.add(radioSort1);	radioSort1.setAlignmentX(JComponent.LEFT_ALIGNMENT);	radioSort1.setOpaque(false); radioSort.add(radioSort1);
			settings.add(radioSort2);	radioSort2.setAlignmentX(JComponent.LEFT_ALIGNMENT);	radioSort2.setOpaque(false); radioSort.add(radioSort2);
			radioSort1.setSelected(true);
		settings.add(Box.createVerticalStrut(20));
		settings.add(new JLabel("闇市場デッキの抽出範囲:"));
		ButtonGroup radioBMarket = new ButtonGroup();
			settings.add(radioBMarket1);	radioBMarket1.setAlignmentX(JComponent.LEFT_ALIGNMENT);	radioBMarket1.setOpaque(false); radioBMarket.add(radioBMarket1);
			settings.add(radioBMarket2);	radioBMarket2.setAlignmentX(JComponent.LEFT_ALIGNMENT);	radioBMarket2.setOpaque(false); radioBMarket.add(radioBMarket2);
			radioBMarket1.setSelected(true);
			settings.add(tmp = new JPanel());
				tmp.setAlignmentX(JComponent.LEFT_ALIGNMENT);
				tmp.setLayout(new BorderLayout());
				tmp.setOpaque(false);
				tmp.add(tmp2 = new JPanel(), BorderLayout.WEST);
				tmp2.setLayout(new BorderLayout());
				tmp2.setOpaque(false);
				tmp2.add(Box.createHorizontalStrut(30), BorderLayout.WEST);
				tmp2.add(showBMarket, BorderLayout.EAST);
				showBMarket.addActionListener(this);

		repaint();
	}

	public void setTabColor(boolean value){
		((SettingPageTab)tab).setTabColor(value);
	}

	/* ゲッタ・セッタ */
	public int getNeedNumber(){ return (Integer)needNumberSpinner.getValue(); }
	public void setNeedNumber(int value){ needNumberSpinner.setValue(value); }
	public boolean getUncheck(){ return checkUncheck.isSelected(); }
	public void setUncheck(boolean value){ checkUncheck.setSelected(value); }
	public boolean getTrash(){ return checkTrash.isSelected(); }
	public void setTrash(boolean value){ checkTrash.setSelected(value); }
	public boolean getAction(){ return checkAction.isSelected(); }
	public void setAction(boolean value){ checkAction.setSelected(value); }
	public boolean getBuy(){ return checkBuy.isSelected(); }
	public void setBuy(boolean value){ checkBuy.setSelected(value); }
	public boolean getOrder(){ return radioSort1.isSelected(); }
	public void setOrder(boolean value){ (value ? radioSort1 : radioSort2).setSelected(true); }
	public boolean getBMarket(){ return radioBMarket1.isSelected(); }
	public void setBMarket(boolean value){ (value ? radioBMarket1 : radioBMarket2).setSelected(true); }

	/* イベントハンドラの設定 */
	public void actionPerformed(ActionEvent e){
		if (e.getSource() == showBMarket){
			showBMarket();
		}
	}

	/* 闇市場デッキ生成器を起動 */
	private void showBMarket(){
		for (Expansion exp : Expansion.allInstances){
			if (!exp.isSelected()) continue;
			for (Card card : exp.cards) card.disabled = false;
		}
		(new BrackMarket(getBMarket())).setVisible(true);
	}
}

